int
main(void)
{
    FRESULT FileResult;

    FIL  fdst; 
    FRESULT res;         // FatFs function common result code
    WORD  bw;//br,         // File R/W count

    char FileName[15];
    unsigned char filemsb,filelsb;
    //
    // Initially wait for device connection.

	//display_saved_record_123(0x01);
    //
    g_eState = STATE_NO_DEVICE;


    //
    // Set the clocking to run directly from the crystal.
    //
 
    SysCtlClockSet(SYSCTL_SYSDIV_5 | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_8MHZ);

     SysCtlBrownOutConfigSet(SYSCTL_BOR_RESET,1000);	// THIS FUNCTION IS USED TO INTERNAL RESET TO CONTROLLER TO SOLVED         THE FLASH CURREPT PROBLEM 


    //
    // Enable Clocking to the USB controller.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_USB0);

    //
    // Enable the peripherals used by this example.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);		 
    
       SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);

    //
    // Set the USB pins to be controlled by the USB controller.
    //
         
    init_display();
	
    init_adc_and_keyboard();
	
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);

    GPIOPinTypeUSBDigital(GPIO_PORTC_BASE, GPIO_PIN_5 | GPIO_PIN_6);

    //
    // The LM3S3748 board uses a USB mux that must be switched to use the
    // host connecter and not the device connecter.
    //

    //
    // Turn on USB Phy clock.
    //
    SysCtlUSBPLLEnable();

    //
    // Set the system tick to fire 100 times per second.
    //
    SysTickPeriodSet(SysCtlClockGet()/100);
    SysTickIntEnable();
    SysTickEnable();

    //
    // Enable the uDMA controller and set up the control table base.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UDMA);
    uDMAEnable();
    uDMAControlBaseSet(g_sDMAControlTable);
	
	
    //
    // Set GPIO A0 and A1 as UART pins.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);//added on 30/04/13 by ganesh sir			

    GPIOPinTypeUART(GPIO_PORTA_BASE,GPIO_PIN_0 | GPIO_PIN_1); //u0tx and u0rx initilized

    UARTStdioInit(0); // @9600 chanes made in c:\stellaris001\uartstdio.c

		display_buffer[0]= 0xEB;
		display_buffer[1]= 0x81;			
	  	display_buffer[2]= 0xDA;			
		display_buffer[3]= 0xD3;	    
		display_buffer[4]= 0xB1;		
						
		display_buffer[5]= 0x73;

		display_buffer[6]= 0x00;
		display_buffer[7]= 0x00;			
	  	display_buffer[8]= 0x00;			

		display_buffer[9]= 0x00;	    
		display_buffer[10]= 0x00;						
		display_buffer[11]= 0x00;

		display_buffer[12]= 0x00;
		display_buffer[13]= 0x00;			
	  	display_buffer[14]= 0x00;			
		display_buffer[15]= 0x78;	    
		
		display_serial();
	
    //
    // Initialize the display driver.
    //
 	display_no_device();
 
    //
    // Register the host class drivers.
    //
    USBHCDRegisterDrivers(0, g_ppHostClassDrivers, g_ulNumHostClassDrivers);

    //
    // Open an instance of the mass storage class driver.
    //
    g_ulMSCInstance = USBHMSCDriveOpen(0, MSCCallback);

    //
    // Initialize the power configuration. This sets the power enable signal
    // to be active high and does not enable the power fault.
    //
    USBHCDPowerConfigInit(0, USB_HOST_PWREN_HIGH);

    //
    // Initialize the host controller.
    //
    USBHCDInit(0, g_pHCDPool, HCD_MEMORY_SIZE);

    //
    // Current directory is "/"
    //
    g_DirData.szPWD[0] = '/';
    g_DirData.szPWD[1] = 0;

    //
    // Initialize the file system.
    //
   	FileInit();
   	IntMasterDisable();
	init_clock();
	IntMasterEnable();
	NewFlashProtect_using_user_dbg();
}

